window.addEventListener("load", _SIlinkerLoad, true);

function _SIlinkerLoad() {
    // initialization code
    
    window.removeEventListener("load", _SIlinkerLoad, true);
    document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", _showSIlinkerItem, false);
}

var _SIlinker_patt1 = new RegExp("^http://((www\.)?)((zhurnal|lit|az|det|fan|world|www.foto)\.lib\.ru)/","i");
var _SIlinker_patt2 = new RegExp("((/[a-z0-9]/[a-z0-9_]+/)[^/?#]+\.shtml)$","i");
var _SIlinker_patt3 = new RegExp("/(index(vote|date|title|_[0-9]+)?\.shtml)?$","i");

var _SIlinker_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.silinker.");

function _showSIlinkerItem() {
    // show or hide the menuitem based on what the context menu is on
    
    var ShowItem = false;
	var ShowItem2= false;

	var isLink = gContextMenu.onLink;
	var aURL = isLink ? gContextMenu.linkURL : gContextMenu.target.ownerDocument.documentURI;
	var aPage = gContextMenu.target.ownerDocument.documentURI;
	
	var arr1 = _SIlinker_patt1.exec(aURL);
	var arr2 = _SIlinker_patt2.exec(aURL);
	
	if(arr1 && arr2) {
		var url= arr1[3] + arr2[1];
		gContextMenu._SIlinker_url = url;
		ShowItem=isLink && (!_SIlinker_patt3.test(aURL));
		ShowItem2=isLink;

		var arr3 = _SIlinker_patt1.exec(aPage);
		
		if(arr3) {
			var arr4 = _SIlinker_patt2.exec(aPage);
			if(arr4) {
				if((arr1[3]==arr3[3])&&(arr2[2]==arr4[2])) ShowItem2=false;
			}
		}
	}

	var ShowItem5 = ShowItem || ShowItem2;
	
	gContextMenu.showItem("context-silinker", ShowItem);
	gContextMenu.showItem("context-silinker-open", ShowItem2);
	gContextMenu.showItem("context-sep-silinker", ShowItem5);	
}

function _SIlinkerOpenTab(aURL,aBkg) {
	//open given URL in new tab
	
	var aDocument=gContextMenu ? gContextMenu.target.ownerDocument : null;
	if (aDocument) urlSecurityCheck(aURL, aDocument.nodePrincipal);

	// open link in new tab
  	var referrerURI = aDocument ? aDocument.documentURIObject : null;
  	var browser = top.document.getElementById("content");
  	browser.loadOneTab(aURL, referrerURI, null, null, aBkg, false);
}
  
function _SIlinkerGetUrl(aFull) {
	// get url, full or truncated

  	//check if mirror needed
	var mirr = _SIlinker_prefs.getBoolPref("usemirr");
	var url = gContextMenu._SIlinker_url;
	
	if(mirr) {
		if(url.substr(0,7)=="zhurnal") {
			url = "www.foto" + url.substr(7);
		}
	}
	else {
		if(url.substr(0,8)=="www.foto") {
			url = "zhurnal" + url.substr(8);
		}
	}
	
	if(!aFull) url = url.substr(0,url.lastIndexOf('/')+1);
	
	return "http://" + url;
}

function _SIlinkerCommand(aBkg) {
  	// open in new tab in SI-reader

    var url=_SIlinkerGetUrl(true);
    
  	//get site address
	var site = _SIlinker_prefs.getCharPref("siteaddr");
    var aURL="http://" + site + "/rider/?hfile=";
    
    for(var i=0;i<url.length;i++) {
    	aURL+=url.charCodeAt(i).toString(16)
    }
    
    aURL+='&silinker';

	_SIlinkerOpenTab(aURL,aBkg);
}

function _SIlinkerOpenAuthor(aBkg) {
  	// open author page in new tab

	var aURL=_SIlinkerGetUrl(false);
	
	_SIlinkerOpenTab(aURL,aBkg);
}
